// BEEditAction.cpp: implementation of the CBEEditAction class.
//
// Copyright (c) 1998 Matt Clay, all rights reserved.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "BEEditAction.h"
#include "BetterEditView.h"

#include <assert.h>

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CBEEditAction::CBEEditAction(CBetterEditView *aView, UINT actionType, void *data)
	: CBETextAction(aView, actionType)
{
}

CBEEditAction::~CBEEditAction()
{

}

void CBEEditAction::Do()
{
	CBEAction::Do();

	// Call helper (subclasses can extend)
	PerformOperation();

	// this is a one-shot action
	Finish();
}

// Actually perform the operation, or tell the view to do it. Subclasses
// should override to provide custom edit-like operations such as insert
// date/time.
 
void CBEEditAction::PerformOperation()
{
	switch (actionType)
	{
		case IDS_CUT_ACTION				: operationTarget->PerformCut(); break;
		case IDS_PASTE_ACTION			: operationTarget->PerformPaste(); break;
		case IDS_CLEAR_ACTION			: operationTarget->PerformClear(); break;
	}
}
