// BEReplaceAction.h: interface for the CBEReplaceAction class.
//
// Copyright (c) 1998 Matt Clay, all rights reserved.
//
// As a subclass of CBEEditAction, this class needs only to redefine
// the PerformOperation() action member function. Saving & restoring
// will be handled by the base class.
//
////////////////////////////////////////////////////////////////////////

#if !defined(BEREPLACEACTION_H)
#define BEREPLACEACTION_H

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "BEEditAction.h"
#include "ReplaceData.h"
#include <list>

class CBEReplaceAction : public CBEEditAction  
{
public:
	CBEReplaceAction(CBetterEditView *aView, UINT actionType, void *data);
	virtual ~CBEReplaceAction();

	void Undo();
	void Redo();

protected:
	void PerformOperation();

	ReplaceData data;

	typedef std::list<CTextRange> ReplacedInfo;
	ReplacedInfo replacedInfo;
};

#endif