// ObjectData.h: interface for the CObjectData class.
//
// Copyright (c) 1998 Matt Clay, all rights reserved.
//
// Utility data structure for storing a single (OLE) object.
//
//////////////////////////////////////////////////////////////////////

#if !defined(OBJECTDATA_H)
#define OBJECTDATA_H

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CObjectData  
{
public:
	CObjectData(long p = 0, DWORD sz = 0, BYTE *st = 0)
		: position(p), size(sz), storage(st) { }
	CObjectData(const CObjectData &od)
		: position(od.position), size(od.size), storage(0)
	{
		if (od.storage)
		{
			storage = (BYTE *)malloc(sizeof(BYTE) * size);
			memcpy(storage, od.storage, size);
		}
	}

	virtual ~CObjectData() { free(storage); }

	const CObjectData &operator=(const CObjectData &od)
	{
		if (this != &od)
		{
			free(storage);
			position = od.position;
			if (od.storage)
			{
				storage = (BYTE *)malloc(sizeof(BYTE) * size);
				memcpy(storage, od.storage, size);
			}
		}

		return *this;
	}

	long position;
	DWORD size;
	BYTE *storage;

};

#endif
