// REAction.h: interface for the CREAction class.
//
// Copyright (c) 1998 Matt Clay, all rights reserved.
//
// Since much of CRich(er)EditView is concerned with typing, all
// all actions have members DoTyping() and CanStillType(), though
// they may be empty. This simplifies recording a sequence of
// changes and treating it as a whole. as an edit view can keep a
// pointer to a CREAction object and query it to see if it can
// accomodate more text.
//
//////////////////////////////////////////////////////////////////////

#if !defined(REACTION_H)
#define REACTION_H

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "Action.h"
#include "TextActionUtil.h"

class CRicherEditView;
class CREAction : public CAction  
{
public:
	CREAction(CRicherEditView *aView, UINT actionType);
	virtual ~CREAction();

						// Defined to regain input focus, not to
						// actual undo or redo any operation.
	virtual void		Undo();
	virtual void		Redo();

						// For recording keystrokes; should override to
						// actual ro actual record or type anything.
	virtual	void		DoTyping(UINT nChar, UINT nRepCnt, UINT nFlags);

						// Indicates whether the current action can record
						// more keystrokes or whether a new typig action
						// must be created. Override to return true.
	virtual	bool		CanStillType() const;

						// target of the operation which the action encapsulates
	CRicherEditView		*operationTarget;			
};

#endif
