// REDropAction.cpp: implementation of the CREDropAction class.
//
// Copyright (c) 1998 Matt Clay, all rights reserved.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "REDropAction.h"
#include "RicherEditView.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CREDropAction::CREDropAction(CRicherEditView *aView, UINT type, long index, COleDataObject *dp, BOOL sd)
	: CRETextAction(aView, type), dropIndex(index), dataObject(dp), selfDrag(sd)
{
}


CREDropAction::~CREDropAction()
{

}
#if 0
void CREDropAction::Do()
{
	CRETextAction::Do();

	// selection dictates what is saved
	// operationTarget->GetTextRange(inserted);
	inserted = deleted;

	const size_t len = inserted.size();
	inserted.end = dropIndex + len;
	inserted.start = dropIndex;

	RestoreRange(inserted);

	if (dropIndex > deleted.start)
	{
		inserted.start -= len;
		inserted.end -= len;
	}

	if (actionType == IDS_MOVE_ACTION)
	{
		// the right way is to delete first, but
		// that doesn't seem to work (below), so
		// we adjust the range, delete it, and re-
		// adjust.

		bool adjustedRange = false;

		if (dropIndex < deleted.start)
		{
			deleted.start += len;
			deleted.end += len;
			adjustedRange = true;
		}

		DeleteRange(deleted);

		if (adjustedRange)
		{
			deleted.start -= len;
			deleted.end -= len;
		}
	}
	else
	{
		// clear the deleted range
		deleted = CTextRange();
	}

	operationTarget->SetSelection(inserted.start, inserted.end);
	neverUndone = false;
}
#endif

#if 0
void CREDropAction::Do()
{
	CRETextAction::Do();

	const size_t len = deleted.size();
	if (dropIndex > deleted.start)
		dropIndex -= len;

	// already saved
	inserted = deleted;
	inserted.selEnd = inserted.end = dropIndex + len;
	inserted.selStart = inserted.start = dropIndex;

	if (actionType == IDS_MOVE_ACTION)
	{
		DeleteRange(deleted);
	}
	else
	{
		deleted = CTextRange();
	}

	RestoreRange(inserted);

	// already saved
	neverUndone = false;
}

#endif

void CREDropAction::Do()
{
	CRETextAction::Do();

	long selStart, selEnd;

	operationTarget->GetSelection(&selStart, &selEnd);

	operationTarget->SetSelection(dropIndex, dropIndex);
//	operationTarget->ImportFromDataObject(dataObject);

	long dummy, dropEnd;
	operationTarget->GetSelection(&dummy, &dropEnd);

	const size_t len = deleted->size();
	if (dropIndex > deleted->start && actionType == IDS_MOVE_ACTION)
	{
		dropIndex -= len;
		dropEnd -= len;
	}
	else if (dropIndex < deleted->start)
	{
		selStart += len;
		selEnd += len;
	}

	inserted->start = dropIndex;
	inserted->end = dropEnd;

	if (selfDrag && actionType == IDS_MOVE_ACTION)
	{
		operationTarget->SetSelection(selStart, selEnd);
		operationTarget->PerformClear();
	}
	else if (actionType == IDS_DUPLICATE_ACTION)
	{
		deleted->start = deleted->end = 0;
	}

	operationTarget->SetSelection(dropIndex, dropEnd);
}
