// REEditAction.cpp: implementation of the CREEditAction class.
//
// Copyright (c) 1998 Matt Clay, all rights reserved.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "REEditAction.h"
#include "RicherEditView.h"

#include <assert.h>

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CREEditAction::CREEditAction(CRicherEditView *aView, UINT actionType, void *data)
	: CRETextAction(aView, actionType)
{
	if (actionType == IDS_PASTESPECIAL_ACTION)
	{
		pasteSpecialData = *(CPasteSpecialData *)data;
	}
}

CREEditAction::~CREEditAction()
{

}

void CREEditAction::Do()
{
	CRETextAction::Do();

	// Call helper (subclasses can extend)
	PerformOperation();

	// this is a one-shot action
	Finish();
}

// Actually perform the operation, or tell the view to do it. Subclasses
// should override to provide custom edit-like operations such as insert
// date/time.
 
void CREEditAction::PerformOperation()
{
	switch (actionType)
	{
		case IDS_CUT_ACTION				: operationTarget->PerformCut(); break;
		case IDS_PASTE_ACTION			: operationTarget->PerformPaste(); break;
		case IDS_PASTESPECIAL_ACTION	: operationTarget->PerformPasteSpecial(pasteSpecialData);
		case IDS_CLEAR_ACTION			: operationTarget->PerformClear(); break;
	}
}
