// REEditAction.h: interface for the CREEditAction class.
//
// Copyright (c) 1998 Matt Clay, all rights reserved.
//
// This class provides support for the common edit operations
// like cut, paste and clear (delete), as well supporting Paste
// Special. It performs an operation then finishes immediately.
// Subclasses should override PerformOperation().
//
//////////////////////////////////////////////////////////////////////

#if !defined(REEDITACTION_H)
#define REEDITACTION_H

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "RETextAction.h"
#include "PasteSpecialData.h"

class CREEditAction : public CRETextAction  
{
public:
						CREEditAction(CRicherEditView *aView,
									  UINT actionType, void *data);
	virtual				~CREEditAction();

						// General interface; saves state and calls DoAction();
						// subclasses probably only need to overrride DoAction().
	virtual	void		Do();

protected:
	virtual void		PerformOperation();

	CPasteSpecialData	pasteSpecialData;
};

#endif
