// REInsertObjectAction.cpp: implementation of the CREInsertObjectAction class.
//
// Copyright (c) 1998 Matt Clay, all rights reserved.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "REInsertObjectAction.h"
#include "RicherEditView.h"

#include <assert.h>
#include <afxodlgs.h>

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CREInsertObjectAction::CREInsertObjectAction(CRicherEditView *aView, UINT actionType, void *data)
	: CRETextAction(aView, actionType)
{
	autoNotify = false;
	if (actionType == IDS_INSERTOBJECT_ACTION)
	{
		insertDialog = (COleInsertDialog *)data;
		assert(insertDialog != 0);
	}
}

CREInsertObjectAction::~CREInsertObjectAction()
{

}

void CREInsertObjectAction::Do()
{
	CRETextAction::Do();

	if (actionType == IDS_INSERTOBJECT_ACTION)
	{
		success = operationTarget->PerformInsertObject(*insertDialog);

		// is pointer to a local var;
		// just a sanity check really
		insertDialog = 0;
	}
}
