// REInsertObjectAction.h: interface for the CREInsertObjectAction class.
//
// Copyright (c) 1998 Matt Clay, all rights reserved.
//
// This class allows undo/redo of object insertion. Unlike other
// actions, it does not have a do phase because of how the
// "Insert Object" command is implemented in CRichEditView (via a
// cancelable dialog box).
//
// See CRicherEditView::OnInsertObject() for more details on how to
// use this class, and in general, how to support dialogs with cancel
// buttons.
//
//////////////////////////////////////////////////////////////////////

#if !defined(REINSERTOBJECTACTION_H)
#define REINSERTOBJECTACTION_H

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "RETextAction.h"

class COleInsertDialog;

class CREInsertObjectAction : public CRETextAction  
{
public:
				CREInsertObjectAction(CRicherEditView *aView, UINT actionType, void *data);
	virtual		~CREInsertObjectAction();

	void		Do();

protected:
	COleInsertDialog *insertDialog;
};

#endif
