// REReplaceAction.h: interface for the CREReplaceAction class.
//
// Copyright (c) 1998 Matt Clay, all rights reserved.
//
// As a subclass of CREEditAction, this class needs only to redefine
// the PerformOperation() action member function. Saving & restoring
// is handled by the base class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(REREPLACEACTION_H)
#define REREPLACEACTION_H

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "REEditAction.h"
#include "ReplaceData.h"
#include <list>

class CREReplaceAction : public CREEditAction  
{
public:
	CREReplaceAction(CRicherEditView *aView, UINT actionType, void *data);
	virtual ~CREReplaceAction();

	void Undo();
	void Redo();

protected:
	void PerformOperation();

	ReplaceData data;

	typedef std::vector<CTextRange *> ReplacedInfo;
	ReplacedInfo replacedInfo;
};

#endif
